#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

void main(void)
 {  

    static LPVOID lpvAddr, commit, vLock;

	// local variables LPVOID lpvAddr; DWORD cbSize; BOOL vLock; LPVOID commit;  
    // amount of memory we'll allocate cbSize = 512;  
    // try to allocate some memory 

    lpvAddr = VirtualAlloc(NULL, 512, MEM_RESERVE,PAGE_NOACCESS);  
    // failed ...
	if(lpvAddr == NULL) 
	  fprintf(stdout,"VirtualAlloc failed on RESERVE with %ld\n", GetLastError());

	// try to commit the allocated memory 
	commit = VirtualAlloc(NULL, 512 ,MEM_COMMIT,PAGE_READONLY|PAGE_GUARD); 

	// failed ...
	if(commit == NULL) 
		fprintf(stderr,"VirtualAlloc failed on COMMIT with %ld\n", GetLastError()); 
	else					// success!
		fprintf(stderr,"Committed 512 bytes at address %lp\n",commit);
		
	// try to lock the committed memory 
	vLock = (void *) VirtualLock(commit,71680);
	
	// failed ...
	
	if(!vLock) 
		fprintf(stderr,"Cannot lock at %lp, error = %x\n", commit,GetLastError()); 
	else					// success!
		fprintf(stderr,"Lock Achieved at %lp\n",commit);  

	// try to lock the committed memory again
	vLock = (void *) VirtualLock(commit,512);
	  
	// failed ... 
	if(!vLock) 
		fprintf(stderr,"Cannot get 2nd lock at %lp, error = %lu\n", commit,GetLastError());
	else  // success!
		fprintf(stderr,"2nd Lock Achieved at %lp\n",commit);
}